var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { Loading } from '../../../components/Loading';

var Button = function Button(_ref) {
  var children = _ref.children,
      htmlType = _ref.htmlType,
      loading = _ref.loading,
      type = _ref.type,
      rest = _objectWithoutProperties(_ref, ['children', 'htmlType', 'loading', 'type']);

  return React.createElement(
    'button',
    _extends({ type: htmlType, className: classNames('button', type) }, rest),
    loading ? React.createElement(Loading, null) : children
  );
};

Button.propTypes = {
  children: PropTypes.node.isRequired,
  htmlType: PropTypes.string.isRequired,
  loading: PropTypes.bool.isRequired,
  type: PropTypes.string.isRequired
};

Button.defaultProps = {
  htmlType: 'button',
  loading: false,
  type: 'default'
};

export default Button;