import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { Svg } from '../../../../components/Svg';

var PreviewCheckbox = function PreviewCheckbox(_ref) {
  var label = _ref.label,
      value = _ref.value;
  return React.createElement(
    'div',
    { className: 'form-field checkbox preview' },
    React.createElement(
      'div',
      null,
      React.createElement(
        'button',
        { type: 'button', className: classNames({ on: value }), disabled: true },
        React.createElement(Svg, { title: 'check-mark' })
      ),
      React.createElement(
        'span',
        { className: 'label' },
        label
      )
    )
  );
};

PreviewCheckbox.propTypes = {
  label: PropTypes.string.isRequired,
  value: PropTypes.bool.isRequired
};

export default PreviewCheckbox;