var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from 'react';
import PropTypes from 'prop-types';
import getFieldClassName from '../../utilities';
import FieldError from '../FieldError';

var InputComponent = function InputComponent(_ref) {
  var input = _ref.input,
      label = _ref.label,
      meta = _ref.meta;
  return React.createElement(
    'div',
    { className: getFieldClassName(meta, 'textarea') },
    React.createElement(
      'label',
      { htmlFor: input.name },
      label
    ),
    React.createElement('textarea', _extends({ id: input.name }, input)),
    React.createElement(FieldError, { state: meta })
  );
};

InputComponent.propTypes = {
  input: PropTypes.object.isRequired,
  label: PropTypes.string.isRequired,
  meta: PropTypes.object.isRequired
};

export default InputComponent;