var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { connect } from 'react-redux';
import { Button, ButtonGroup } from '../../../components/Buttons';
import { removeModal } from '../store';

var ModalConfirm = function (_Component) {
  _inherits(ModalConfirm, _Component);

  function ModalConfirm() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ModalConfirm);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ModalConfirm.__proto__ || Object.getPrototypeOf(ModalConfirm)).call.apply(_ref, [this].concat(args))), _this), _this.handleKeyDownEvent = function (e) {
      if (e.keyCode === 27 && _this.props.top) {
        _this.closeModal();
      }
    }, _this.handleSubmitClick = function () {
      _this.props.onSubmit();
      _this.closeModal();
    }, _this.handleCloseClick = function () {
      _this.closeModal();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ModalConfirm, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      document.addEventListener('keydown', this.handleKeyDownEvent, false);
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate() {
      return false;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener('keydown', this.handleKeyDownEvent, false);
    }
  }, {
    key: 'closeModal',
    value: function closeModal() {
      this.props.dispatch(removeModal(this.props.modalId));
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          message = _props.message,
          title = _props.title;


      return React.createElement(
        'section',
        { className: 'modal-confirm' },
        React.createElement(
          'header',
          null,
          React.createElement(
            'h1',
            null,
            title
          )
        ),
        React.createElement(
          'p',
          null,
          message
        ),
        React.createElement(
          'footer',
          null,
          React.createElement(
            ButtonGroup,
            null,
            React.createElement(
              Button,
              { type: 'primary', onClick: this.handleSubmitClick, autoFocus: true },
              'Confirm'
            ),
            React.createElement(
              Button,
              { onClick: this.handleCloseClick },
              'Cancel'
            )
          )
        )
      );
    }
  }]);

  return ModalConfirm;
}(Component);

ModalConfirm.propTypes = {
  message: PropTypes.string.isRequired,
  modalId: PropTypes.number.isRequired,
  title: PropTypes.string.isRequired,
  top: PropTypes.bool.isRequired,
  dispatch: PropTypes.func.isRequired,
  onSubmit: PropTypes.func.isRequired
};

export default connect()(ModalConfirm);