var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { connect } from 'react-redux';
import { withRouter } from 'react-router-dom';
import Helmet from 'react-helmet';
import { removeModals } from '../store';
import confirm from '../utilities';

var ModalRoute = function (_Component) {
  _inherits(ModalRoute, _Component);

  function ModalRoute() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ModalRoute);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ModalRoute.__proto__ || Object.getPrototypeOf(ModalRoute)).call.apply(_ref, [this].concat(args))), _this), _this.handleKeyPress = function (e) {
      if (e.keyCode === 27 && !_this.props.modals.length) {
        _this.closeModalRoute();
      }
    }, _this.handleOverlayClick = function (e) {
      if (e.target === _this.component) {
        _this.closeModalRoute();
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ModalRoute, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      document.addEventListener('keydown', this.handleKeyPress, false);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener('keydown', this.handleKeyPress, false);
      this.props.dispatch(removeModals());
    }
  }, {
    key: 'closeModalRoute',
    value: function closeModalRoute() {
      var _this2 = this;

      if (this.props.confirmOnClose) {
        confirm({
          title: 'Close?',
          message: 'Unsaved data will be lost.',
          onSubmit: function onSubmit() {
            _this2.props.history.goBack();
          }
        });
      } else {
        this.props.history.goBack();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props,
          children = _props.children,
          title = _props.title;


      return React.createElement(
        'section',
        {
          ref: function ref(c) {
            _this3.component = c;
          },
          className: 'modal-overlay',
          onClick: this.handleOverlayClick
        },
        title && React.createElement(
          Helmet,
          null,
          React.createElement(
            'title',
            null,
            title
          )
        ),
        children
      );
    }
  }]);

  return ModalRoute;
}(Component);

ModalRoute.propTypes = {
  children: PropTypes.node.isRequired,
  confirmOnClose: PropTypes.bool.isRequired,
  history: PropTypes.object.isRequired,
  modals: PropTypes.array.isRequired,
  title: PropTypes.string,
  dispatch: PropTypes.func.isRequired
};

ModalRoute.defaultProps = {
  confirmOnClose: false
};

export default connect(function (_ref2) {
  var modals = _ref2.modals;
  return {
    modals: modals
  };
})(withRouter(ModalRoute));