import React from 'react';
import PropTypes from 'prop-types';
import ModalRoute from './ModalRoute';

var ModalRoutePage = function ModalRoutePage(_ref) {
  var children = _ref.children,
      confirmOnClose = _ref.confirmOnClose,
      title = _ref.title;
  return React.createElement(
    ModalRoute,
    { title: title, confirmOnClose: confirmOnClose },
    React.createElement(
      'section',
      { className: 'card modal-page' },
      title && React.createElement(
        'header',
        null,
        React.createElement(
          'h1',
          null,
          title
        )
      ),
      children
    )
  );
};

ModalRoutePage.propTypes = {
  children: PropTypes.node.isRequired,
  confirmOnClose: PropTypes.bool,
  title: PropTypes.string
};

export default ModalRoutePage;