var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from 'react';
import PropTypes from 'prop-types';
import { connect } from 'react-redux';
import { modalTypes } from '../store';

var Modals = function Modals(_ref) {
  var modals = _ref.modals;

  var modalsCount = modals.length;

  if (modalsCount) {
    return React.createElement(
      'aside',
      { className: 'modals' },
      modals.map(function (modal, i) {
        var isTop = modalsCount === i + 1;
        var id = modal.id,
            component = modal.component,
            props = modal.props;

        var InnerComponent = modalTypes[component];

        return React.createElement(
          'section',
          { key: modal.id, className: 'modal-overlay' },
          React.createElement(InnerComponent, _extends({ modalId: id }, props, { top: isTop }))
        );
      })
    );
  }

  return null;
};

Modals.propTypes = {
  modals: PropTypes.array.isRequired
};

export default connect(function (_ref2) {
  var modals = _ref2.modals;
  return {
    modals: modals
  };
})(Modals);