function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var MODALS_ADD_MODAL = 'MODALS_ADD_MODAL';
var MODALS_REMOVE_MODAL = 'MODALS_REMOVE_MODAL';
var MODALS_REMOVE_MODALS = 'MODALS_REMOVE_MODALS';

export var modalTypes = [];

var nextModalId = 0;

var initialState = [];

// Actions
export function addModal(component, props) {
  nextModalId += 1;

  return {
    type: MODALS_ADD_MODAL,
    modal: {
      id: nextModalId,
      component: component,
      props: props
    }
  };
}

export function removeModal(id) {
  return {
    type: MODALS_REMOVE_MODAL,
    id: id
  };
}

export function removeModals() {
  return {
    type: MODALS_REMOVE_MODALS
  };
}

// Reducer
export function modalsReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments[1];

  switch (action.type) {
    case MODALS_ADD_MODAL:
      return [].concat(_toConsumableArray(state), [action.modal]);
    case MODALS_REMOVE_MODAL:
      return state.filter(function (modal) {
        return modal.id !== action.id;
      });
    case MODALS_REMOVE_MODALS:
      return initialState;
    default:
      return state;
  }
}