function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

export default function sort(items, sortingColumn, sortingType, sortingOrder) {
  switch (sortingType) {
    case 'string':
      return [].concat(_toConsumableArray(items)).sort(function (a, b) {
        if (a[sortingColumn] === null) {
          return 1;
        }

        if (b[sortingColumn] === null) {
          return -1;
        }

        if (a[sortingColumn] === b[sortingColumn]) {
          return 0;
        }

        if (a[sortingColumn].toLowerCase() < b[sortingColumn].toLowerCase()) {
          return sortingOrder === 'asc' ? -1 : 1;
        }

        return sortingOrder === 'asc' ? 1 : -1;
      });
    case 'number':
      return [].concat(_toConsumableArray(items)).sort(function (a, b) {
        return sortingOrder === 'desc' ? parseFloat(b[sortingColumn]) - parseFloat(a[sortingColumn]) : parseFloat(a[sortingColumn]) - parseFloat(b[sortingColumn]);
      });
    default:
      return items;
  }
}