var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import { createStore, combineReducers } from 'redux';
import { reducer as formReducer } from 'redux-form';
import { devToolsEnhancer } from 'redux-devtools-extension/developmentOnly';
import { notificationsReducer } from '../../components/Notifications';
import { modalsReducer } from '../../components/Modals';
import { authReducer } from '../../scenes/Auth';

// eslint-disable-next-line import/no-mutable-exports
export var store = void 0;

export function configureStore() {
  var reducers = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var initialState = arguments[1];

  store = createStore(combineReducers(_extends({
    form: formReducer,
    auth: authReducer,
    notifications: notificationsReducer,
    modals: modalsReducer
  }, reducers)), initialState, devToolsEnhancer());

  return store;
}