export function getObjectValue(object, key) {
  return key.split('.').reduce(function (accumulator, currentKey) {
    if (!accumulator[currentKey]) {
      throw new Error('No value specified for ' + key);
    }

    return accumulator[currentKey];
  }, object);
}

export function getDisplayName(component) {
  return component.displayName || component.name || 'Component';
}

export function replacePlaceholders(string, placeholders) {
  return string.replace(/:([a-z]+)/ig, function (match, group) {
    return placeholders[group] || match;
  });
}