var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { connect } from 'react-redux';
import { withRouter } from 'react-router-dom';
import { Loading } from '../../../components/Loading';
import { checkToken } from '../utilities';

var SecuredComponent = function (_Component) {
  _inherits(SecuredComponent, _Component);

  function SecuredComponent() {
    _classCallCheck(this, SecuredComponent);

    return _possibleConstructorReturn(this, (SecuredComponent.__proto__ || Object.getPrototypeOf(SecuredComponent)).apply(this, arguments));
  }

  _createClass(SecuredComponent, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      if (!this.props.isAuthenticated) {
        checkToken().catch(function () {
          _this2.props.history.push('/login', { redirectPath: _this2.props.location.pathname });
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          isAuthenticated = _props.isAuthenticated,
          isTokenChecking = _props.isTokenChecking;


      if (isTokenChecking) {
        return React.createElement(Loading, null);
      }

      if (isAuthenticated) {
        return this.props.children;
      }

      return null;
    }
  }]);

  return SecuredComponent;
}(Component);

SecuredComponent.propTypes = {
  children: PropTypes.node.isRequired,
  history: PropTypes.object.isRequired,
  isAuthenticated: PropTypes.bool.isRequired,
  isTokenChecking: PropTypes.bool.isRequired,
  location: PropTypes.object.isRequired
};

export default connect(function (_ref) {
  var _ref$auth = _ref.auth,
      isAuthenticated = _ref$auth.isAuthenticated,
      isTokenChecking = _ref$auth.isTokenChecking;
  return {
    isAuthenticated: isAuthenticated,
    isTokenChecking: isTokenChecking
  };
})(withRouter(SecuredComponent));