var AUTH_SET_CURRENT_USER = 'AUTH_SET_CURRENT_USER';
var AUTH_REMOVE_CURRENT_USER = 'AUTH_REMOVE_CURRENT_USER';
var AUTH_TOKEN_CHECK_START = 'AUTH_TOKEN_CHECK_START';
var AUTH_TOKEN_CHECK_SUCCESS = 'AUTH_TOKEN_CHECK_SUCCESS';
var AUTH_TOKEN_CHECK_FAILURE = 'AUTH_TOKEN_CHECK_FAILURE';

var initialState = {
  isAuthenticated: false,
  isTokenChecking: false,
  user: null

  // Actions
};export function setCurrentUser(user) {
  return {
    type: AUTH_SET_CURRENT_USER,
    user: user
  };
}

export function removeCurrentUser() {
  return {
    type: AUTH_REMOVE_CURRENT_USER
  };
}

export function tokenCheckStart() {
  return {
    type: AUTH_TOKEN_CHECK_START
  };
}

export function tokenCheckSuccess(user) {
  return {
    type: AUTH_TOKEN_CHECK_SUCCESS,
    user: user
  };
}

export function tokenCheckFailure() {
  return {
    type: AUTH_TOKEN_CHECK_FAILURE
  };
}

// Reducer
export default function authReducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments[1];

  switch (action.type) {
    case AUTH_SET_CURRENT_USER:
      return Object.assign({}, state, {
        isAuthenticated: true,
        user: action.user
      });
    case AUTH_REMOVE_CURRENT_USER:
      return initialState;
    case AUTH_TOKEN_CHECK_START:
      return Object.assign({}, initialState, {
        isTokenChecking: true
      });
    case AUTH_TOKEN_CHECK_SUCCESS:
      return {
        isTokenChecking: false,
        isAuthenticated: true,
        user: action.user
      };
    case AUTH_TOKEN_CHECK_FAILURE:
      return Object.assign({}, initialState, {
        isTokenChecking: false
      });
    default:
      return state;
  }
}