function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

import cookie from 'js-cookie';
import jwtDecode from 'jwt-decode';
import { store } from '../../modules/store';
import postRequest from '../../modules/api';
import { setCurrentUser, removeCurrentUser, tokenCheckStart, tokenCheckSuccess, tokenCheckFailure } from './store';

function decodeUser(token) {
  var _jwtDecode = jwtDecode(token),
      id = _jwtDecode.id,
      username = _jwtDecode.username;

  return {
    id: id,
    username: username
  };
}

export function loginUser(values) {
  return postRequest('/api/login', values).then(function (res) {
    cookie.set('token', res.token);
    store.dispatch(setCurrentUser(decodeUser(res.token)));
  });
}

export var checkToken = function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
    var currentToken, req;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            currentToken = cookie.get('token');

            if (!currentToken) {
              _context.next = 21;
              break;
            }

            store.dispatch(tokenCheckStart());

            _context.prev = 3;
            _context.next = 6;
            return postRequest('/api/check-token', { token: currentToken });

          case 6:
            req = _context.sent;

            if (!req.valid) {
              _context.next = 11;
              break;
            }

            store.dispatch(tokenCheckSuccess(decodeUser(currentToken)));
            _context.next = 13;
            break;

          case 11:
            cookie.remove('token');
            throw new Error('Token mismatch');

          case 13:
            _context.next = 19;
            break;

          case 15:
            _context.prev = 15;
            _context.t0 = _context['catch'](3);

            store.dispatch(tokenCheckFailure());
            throw new Error('Token error');

          case 19:
            _context.next = 22;
            break;

          case 21:
            throw new Error('Access denied');

          case 22:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[3, 15]]);
  }));

  return function checkToken() {
    return _ref.apply(this, arguments);
  };
}();

export function logoutUser() {
  return new Promise(function (resolve) {
    cookie.remove('token');
    store.dispatch(removeCurrentUser());
    resolve();
  });
}