import React from 'react';
import PropTypes from 'prop-types';
import Helmet from 'react-helmet';
import { Navigation } from '../../../components/Navigation';
import { Notifications } from '../../../components/Notifications';
import { Modals } from '../../../components/Modals';

var Layout = function Layout(_ref) {
  var children = _ref.children,
      icons = _ref.icons,
      menuItems = _ref.menuItems,
      title = _ref.title;
  return React.createElement(
    'section',
    { className: 'department-contents' },
    React.createElement(
      Helmet,
      null,
      React.createElement(
        'title',
        null,
        title
      )
    ),
    icons && icons(),
    React.createElement(Navigation, { items: menuItems }),
    React.createElement(
      'main',
      { className: 'department-main' },
      children
    ),
    React.createElement(Notifications, null),
    React.createElement(Modals, null)
  );
};

Layout.propTypes = {
  children: PropTypes.node.isRequired,
  icons: PropTypes.func,
  menuItems: PropTypes.array.isRequired,
  title: PropTypes.string
};

Layout.defaultProps = {
  title: 'Department'
};

export default Layout;