'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Loading = require('../../../components/Loading');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Button = function Button(_ref) {
  var children = _ref.children,
      htmlType = _ref.htmlType,
      loading = _ref.loading,
      type = _ref.type,
      rest = _objectWithoutProperties(_ref, ['children', 'htmlType', 'loading', 'type']);

  return _react2.default.createElement(
    'button',
    _extends({ type: htmlType, className: (0, _classnames2.default)('button', type) }, rest),
    loading ? _react2.default.createElement(_Loading.Loading, null) : children
  );
};

Button.propTypes = {
  children: _propTypes2.default.node.isRequired,
  htmlType: _propTypes2.default.string.isRequired,
  loading: _propTypes2.default.bool.isRequired,
  type: _propTypes2.default.string.isRequired
};

Button.defaultProps = {
  htmlType: 'button',
  loading: false,
  type: 'default'
};

exports.default = Button;