'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utilities = require('../../utilities');

var _utilities2 = _interopRequireDefault(_utilities);

var _FieldError = require('../FieldError');

var _FieldError2 = _interopRequireDefault(_FieldError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var InputComponent = function InputComponent(_ref) {
  var input = _ref.input,
      label = _ref.label,
      meta = _ref.meta,
      type = _ref.type;
  return _react2.default.createElement(
    'div',
    { className: (0, _utilities2.default)(meta) },
    _react2.default.createElement(
      'label',
      { htmlFor: input.name },
      label
    ),
    _react2.default.createElement('input', _extends({ type: type, id: input.name }, input)),
    _react2.default.createElement(_FieldError2.default, { state: meta })
  );
};

InputComponent.propTypes = {
  input: _propTypes2.default.object.isRequired,
  label: _propTypes2.default.string.isRequired,
  meta: _propTypes2.default.object.isRequired,
  type: _propTypes2.default.string.isRequired
};

exports.default = InputComponent;