'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _Buttons = require('../../../components/Buttons');

var _store = require('../store');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ModalConfirm = function (_Component) {
  _inherits(ModalConfirm, _Component);

  function ModalConfirm() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ModalConfirm);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ModalConfirm.__proto__ || Object.getPrototypeOf(ModalConfirm)).call.apply(_ref, [this].concat(args))), _this), _this.handleKeyDownEvent = function (e) {
      if (e.keyCode === 27 && _this.props.top) {
        _this.closeModal();
      }
    }, _this.handleSubmitClick = function () {
      _this.props.onSubmit();
      _this.closeModal();
    }, _this.handleCloseClick = function () {
      _this.closeModal();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ModalConfirm, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      document.addEventListener('keydown', this.handleKeyDownEvent, false);
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate() {
      return false;
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener('keydown', this.handleKeyDownEvent, false);
    }
  }, {
    key: 'closeModal',
    value: function closeModal() {
      this.props.dispatch((0, _store.removeModal)(this.props.modalId));
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          message = _props.message,
          title = _props.title;


      return _react2.default.createElement(
        'section',
        { className: 'modal-confirm' },
        _react2.default.createElement(
          'header',
          null,
          _react2.default.createElement(
            'h1',
            null,
            title
          )
        ),
        _react2.default.createElement(
          'p',
          null,
          message
        ),
        _react2.default.createElement(
          'footer',
          null,
          _react2.default.createElement(
            _Buttons.ButtonGroup,
            null,
            _react2.default.createElement(
              _Buttons.Button,
              { type: 'primary', onClick: this.handleSubmitClick, autoFocus: true },
              'Confirm'
            ),
            _react2.default.createElement(
              _Buttons.Button,
              { onClick: this.handleCloseClick },
              'Cancel'
            )
          )
        )
      );
    }
  }]);

  return ModalConfirm;
}(_react.Component);

ModalConfirm.propTypes = {
  message: _propTypes2.default.string.isRequired,
  modalId: _propTypes2.default.number.isRequired,
  title: _propTypes2.default.string.isRequired,
  top: _propTypes2.default.bool.isRequired,
  dispatch: _propTypes2.default.func.isRequired,
  onSubmit: _propTypes2.default.func.isRequired
};

exports.default = (0, _reactRedux.connect)()(ModalConfirm);