'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _reactRouterDom = require('react-router-dom');

var _reactHelmet = require('react-helmet');

var _reactHelmet2 = _interopRequireDefault(_reactHelmet);

var _store = require('../store');

var _utilities = require('../utilities');

var _utilities2 = _interopRequireDefault(_utilities);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ModalRoute = function (_Component) {
  _inherits(ModalRoute, _Component);

  function ModalRoute() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ModalRoute);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ModalRoute.__proto__ || Object.getPrototypeOf(ModalRoute)).call.apply(_ref, [this].concat(args))), _this), _this.handleKeyPress = function (e) {
      if (e.keyCode === 27 && !_this.props.modals.length) {
        _this.closeModalRoute();
      }
    }, _this.handleOverlayClick = function (e) {
      if (e.target === _this.component) {
        _this.closeModalRoute();
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ModalRoute, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      document.addEventListener('keydown', this.handleKeyPress, false);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      document.removeEventListener('keydown', this.handleKeyPress, false);
      this.props.dispatch((0, _store.removeModals)());
    }
  }, {
    key: 'closeModalRoute',
    value: function closeModalRoute() {
      var _this2 = this;

      if (this.props.confirmOnClose) {
        (0, _utilities2.default)({
          title: 'Close?',
          message: 'Unsaved data will be lost.',
          onSubmit: function onSubmit() {
            _this2.props.history.goBack();
          }
        });
      } else {
        this.props.history.goBack();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props,
          children = _props.children,
          title = _props.title;


      return _react2.default.createElement(
        'section',
        {
          ref: function ref(c) {
            _this3.component = c;
          },
          className: 'modal-overlay',
          onClick: this.handleOverlayClick
        },
        title && _react2.default.createElement(
          _reactHelmet2.default,
          null,
          _react2.default.createElement(
            'title',
            null,
            title
          )
        ),
        children
      );
    }
  }]);

  return ModalRoute;
}(_react.Component);

ModalRoute.propTypes = {
  children: _propTypes2.default.node.isRequired,
  confirmOnClose: _propTypes2.default.bool.isRequired,
  history: _propTypes2.default.object.isRequired,
  modals: _propTypes2.default.array.isRequired,
  title: _propTypes2.default.string,
  dispatch: _propTypes2.default.func.isRequired
};

ModalRoute.defaultProps = {
  confirmOnClose: false
};

exports.default = (0, _reactRedux.connect)(function (_ref2) {
  var modals = _ref2.modals;
  return {
    modals: modals
  };
})((0, _reactRouterDom.withRouter)(ModalRoute));