'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _store = require('../store');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Modals = function Modals(_ref) {
  var modals = _ref.modals;

  var modalsCount = modals.length;

  if (modalsCount) {
    return _react2.default.createElement(
      'aside',
      { className: 'modals' },
      modals.map(function (modal, i) {
        var isTop = modalsCount === i + 1;
        var id = modal.id,
            component = modal.component,
            props = modal.props;

        var InnerComponent = _store.modalTypes[component];

        return _react2.default.createElement(
          'section',
          { key: modal.id, className: 'modal-overlay' },
          _react2.default.createElement(InnerComponent, _extends({ modalId: id }, props, { top: isTop }))
        );
      })
    );
  }

  return null;
};

Modals.propTypes = {
  modals: _propTypes2.default.array.isRequired
};

exports.default = (0, _reactRedux.connect)(function (_ref2) {
  var modals = _ref2.modals;
  return {
    modals: modals
  };
})(Modals);