'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utilities = require('../utilities');

var _utilities2 = _interopRequireDefault(_utilities);

var _TableHeaderColumn = require('./TableHeaderColumn');

var _TableHeaderColumn2 = _interopRequireDefault(_TableHeaderColumn);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Table = function (_Component) {
  _inherits(Table, _Component);

  function Table() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Table);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Table.__proto__ || Object.getPrototypeOf(Table)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      sortingColumn: _this.props.defaultSortColumn,
      sortingOrder: _this.props.defaultSortOrder
    }, _this.handleSortClick = function (columnTitle) {
      var _this$state = _this.state,
          sortingColumn = _this$state.sortingColumn,
          sortingOrder = _this$state.sortingOrder;


      if (sortingColumn === columnTitle) {
        _this.setState({
          sortingOrder: sortingOrder === 'asc' ? 'desc' : 'asc'
        });
      } else {
        _this.setState({
          sortingColumn: columnTitle,
          sortingOrder: 'asc'
        });
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Table, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          columns = _props.columns,
          items = _props.items;
      var _state = this.state,
          sortingColumn = _state.sortingColumn,
          sortingOrder = _state.sortingOrder;

      var sortedItems = items;

      if (sortingColumn) {
        var sortingType = columns.find(function (column) {
          return column.itemKey === sortingColumn;
        }).type;

        sortedItems = (0, _utilities2.default)(items, sortingColumn, sortingType, sortingOrder);
      }

      return _react2.default.createElement(
        'table',
        { className: 'table' },
        _react2.default.createElement(
          'thead',
          null,
          _react2.default.createElement(
            'tr',
            null,
            columns.map(function (column) {
              return _react2.default.createElement(_TableHeaderColumn2.default, {
                key: column.itemKey,
                column: column,
                currentSortingColumn: sortingColumn,
                currentSortingOrder: sortingOrder,
                handleSortClick: _this2.handleSortClick
              });
            })
          )
        ),
        _react2.default.createElement(
          'tbody',
          null,
          sortedItems.map(function (item) {
            return _react2.default.createElement(
              'tr',
              { key: item.id },
              columns.map(function (column) {
                return _react2.default.createElement(
                  'td',
                  {
                    key: column.itemKey,
                    className: (0, _classnames2.default)(column.align),
                    style: { width: column.width + '%' }
                  },
                  column.render ? column.render(item, _this2.props) : item[column.itemKey]
                );
              })
            );
          })
        )
      );
    }
  }]);

  return Table;
}(_react.Component);

Table.propTypes = {
  columns: _propTypes2.default.array.isRequired,
  defaultSortColumn: _propTypes2.default.string.isRequired,
  defaultSortOrder: _propTypes2.default.string.isRequired,
  items: _propTypes2.default.array.isRequired
};

Table.defaultProps = {
  defaultSortOrder: 'asc'
};

exports.default = Table;