'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.store = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.configureStore = configureStore;

var _redux = require('redux');

var _reduxForm = require('redux-form');

var _developmentOnly = require('redux-devtools-extension/developmentOnly');

var _Notifications = require('../../components/Notifications');

var _Modals = require('../../components/Modals');

var _Auth = require('../../scenes/Auth');

// eslint-disable-next-line import/no-mutable-exports
var store = exports.store = void 0;

function configureStore() {
  var reducers = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var initialState = arguments[1];

  exports.store = store = (0, _redux.createStore)((0, _redux.combineReducers)(_extends({
    form: _reduxForm.reducer,
    auth: _Auth.authReducer,
    notifications: _Notifications.notificationsReducer,
    modals: _Modals.modalsReducer
  }, reducers)), initialState, (0, _developmentOnly.devToolsEnhancer)());

  return store;
}