'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _reactRouterDom = require('react-router-dom');

var _Loading = require('../../../components/Loading');

var _utilities = require('../utilities');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SecuredComponent = function (_Component) {
  _inherits(SecuredComponent, _Component);

  function SecuredComponent() {
    _classCallCheck(this, SecuredComponent);

    return _possibleConstructorReturn(this, (SecuredComponent.__proto__ || Object.getPrototypeOf(SecuredComponent)).apply(this, arguments));
  }

  _createClass(SecuredComponent, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      if (!this.props.isAuthenticated) {
        (0, _utilities.checkToken)().catch(function () {
          _this2.props.history.push('/login', { redirectPath: _this2.props.location.pathname });
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          isAuthenticated = _props.isAuthenticated,
          isTokenChecking = _props.isTokenChecking;


      if (isTokenChecking) {
        return _react2.default.createElement(_Loading.Loading, null);
      }

      if (isAuthenticated) {
        return this.props.children;
      }

      return null;
    }
  }]);

  return SecuredComponent;
}(_react.Component);

SecuredComponent.propTypes = {
  children: _propTypes2.default.node.isRequired,
  history: _propTypes2.default.object.isRequired,
  isAuthenticated: _propTypes2.default.bool.isRequired,
  isTokenChecking: _propTypes2.default.bool.isRequired,
  location: _propTypes2.default.object.isRequired
};

exports.default = (0, _reactRedux.connect)(function (_ref) {
  var _ref$auth = _ref.auth,
      isAuthenticated = _ref$auth.isAuthenticated,
      isTokenChecking = _ref$auth.isTokenChecking;
  return {
    isAuthenticated: isAuthenticated,
    isTokenChecking: isTokenChecking
  };
})((0, _reactRouterDom.withRouter)(SecuredComponent));