'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.checkToken = undefined;

var checkToken = exports.checkToken = function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
    var currentToken, req;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            currentToken = _jsCookie2.default.get('token');

            if (!currentToken) {
              _context.next = 21;
              break;
            }

            _store.store.dispatch((0, _store2.tokenCheckStart)());

            _context.prev = 3;
            _context.next = 6;
            return (0, _api2.default)('/api/check-token', { token: currentToken });

          case 6:
            req = _context.sent;

            if (!req.valid) {
              _context.next = 11;
              break;
            }

            _store.store.dispatch((0, _store2.tokenCheckSuccess)(decodeUser(currentToken)));
            _context.next = 13;
            break;

          case 11:
            _jsCookie2.default.remove('token');
            throw new Error('Token mismatch');

          case 13:
            _context.next = 19;
            break;

          case 15:
            _context.prev = 15;
            _context.t0 = _context['catch'](3);

            _store.store.dispatch((0, _store2.tokenCheckFailure)());
            throw new Error('Token error');

          case 19:
            _context.next = 22;
            break;

          case 21:
            throw new Error('Access denied');

          case 22:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[3, 15]]);
  }));

  return function checkToken() {
    return _ref.apply(this, arguments);
  };
}();

exports.loginUser = loginUser;
exports.logoutUser = logoutUser;

var _jsCookie = require('js-cookie');

var _jsCookie2 = _interopRequireDefault(_jsCookie);

var _jwtDecode2 = require('jwt-decode');

var _jwtDecode3 = _interopRequireDefault(_jwtDecode2);

var _store = require('../../modules/store');

var _api = require('../../modules/api');

var _api2 = _interopRequireDefault(_api);

var _store2 = require('./store');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function decodeUser(token) {
  var _jwtDecode = (0, _jwtDecode3.default)(token),
      id = _jwtDecode.id,
      username = _jwtDecode.username;

  return {
    id: id,
    username: username
  };
}

function loginUser(values) {
  return (0, _api2.default)('/api/login', values).then(function (res) {
    _jsCookie2.default.set('token', res.token);
    _store.store.dispatch((0, _store2.setCurrentUser)(decodeUser(res.token)));
  });
}

function logoutUser() {
  return new Promise(function (resolve) {
    _jsCookie2.default.remove('token');
    _store.store.dispatch((0, _store2.removeCurrentUser)());
    resolve();
  });
}