'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactHelmet = require('react-helmet');

var _reactHelmet2 = _interopRequireDefault(_reactHelmet);

var _Navigation = require('../../../components/Navigation');

var _Notifications = require('../../../components/Notifications');

var _Modals = require('../../../components/Modals');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Layout = function Layout(_ref) {
  var children = _ref.children,
      icons = _ref.icons,
      menuItems = _ref.menuItems,
      title = _ref.title;
  return _react2.default.createElement(
    'section',
    { className: 'department-contents' },
    _react2.default.createElement(
      _reactHelmet2.default,
      null,
      _react2.default.createElement(
        'title',
        null,
        title
      )
    ),
    icons && icons(),
    _react2.default.createElement(_Navigation.Navigation, { items: menuItems }),
    _react2.default.createElement(
      'main',
      { className: 'department-main' },
      children
    ),
    _react2.default.createElement(_Notifications.Notifications, null),
    _react2.default.createElement(_Modals.Modals, null)
  );
};

Layout.propTypes = {
  children: _propTypes2.default.node.isRequired,
  icons: _propTypes2.default.func,
  menuItems: _propTypes2.default.array.isRequired,
  title: _propTypes2.default.string
};

Layout.defaultProps = {
  title: 'Department'
};

exports.default = Layout;